// 预览混入
import AudioPlay from '@/views/exercise_questions/create/components/common/AudioPlay.vue';
import DOMPurify from 'dompurify';

import { isEnable } from '@/views/exercise_questions/data/common';

const PreviewMixin = {
  props: {
    data: {
      type: Object,
      required: true,
    },
  },
  components: {
    AudioPlay,
  },
  data() {
    return {
      isEnable,
      answer: { answer_list: [] }, // 答案
    };
  },
  watch: {
    answer: {
      handler() {
        this.$emit('change', this.answer);
      },
      deep: true,
      immediate: true,
    },
  },
  methods: {
    /**
     * 获取答案
     * @returns {Array} 答案
     */
    getAnswer() {
      return this.answer;
    },
    /**
     * 过滤 html，防止 xss 攻击
     * @param {String} html 需要过滤的html
     * @returns {String} 过滤后的html
     */
    sanitizeHTML(html) {
      return DOMPurify.sanitize(html);
    },
  },
};

export default PreviewMixin;
